fs = require "fs"
_ = require "underscore"

dk.extendPlugin "model", ["assets", "couchdb", "transport"], (modelClass) ->

  # ADD PUBLIC METHODS
  
  classMethods =
    views: {}

    updateSchema: ->
      # TODO: Figure out why dk.model.storage works, but model.storage does not
      dk.model.storage.updateViews this.modelName, this.views

    view: (name, funcOrObj) ->
      model = this
      this.views[name] = funcOrObj
      this[name] = (opts, cb) ->
        if _.isFunction opts
          cb = opts
          opts = {}

        # TODO: Figure out why dk.model.storage works, but model.storage does not
        dk.model.storage.view "#{this.modelName}/#{name}", opts, (err, objs) ->
          if err
            cb err
          else
            objs ?= []
            models = for data in objs
              new model(data)
            cb null, models

      dk.transport.on "model.#{this.modelName}.#{name}", (data, cb) ->
        model[name] (err, items) ->
          items ?= []
          allAtts = for m in items
            m.attributes
          cb allAtts


  # EXECUTE CODE ON MODEL
  origRun = modelClass.run

  modelClass.run = ->
    dk.assets.package "/js/dk-model-couchdb.js", "#{__dirname}/../public/js/dk-model-couchdb.coffee"

    config = JSON.parse(fs.readFileSync "#{process.cwd()}/database.json")[dk.env]

    modelClass.config storage: new dk.couchdb(config.database, config)

    modelClass.beforeInit = ->
      _.extend this, classMethods

      this.view "all", (doc) ->
        emit(doc.id, doc)

    modelClass.afterInit = ->
      this.updateSchema()

    origRun()

  modelClass


dk.extendPlugin "couchdb", (couchdb) ->

  # PUBLIC METHODS
  couchdb.prototype.updateViews = (modelName, viewDoc) ->
    doc = {}
    for name, funcOrObj of viewDoc
      if _.isFunction(funcOrObj)
        doc[name] = {map: modelNamize modelName, funcOrObj}
      else
        funcOrObj.map = modelNamize funcOrObj.map
        doc[name] = funcOrObj

    @db.save "_design/#{modelName}", doc

  # PRIVATE METHODS
  modelNamize = (name, func) ->
    str = func.toString()
    varname = str.match(/\(([^\)]+)\)/)[1]
    str.replace "{", "{ if(#{varname}.dkModelName != '#{name}') { return; } "

  couchdb
